#include <stdio.h>			//
#include <stdlib.h>			//
#include <string.h>			//

/* Copyright (c) 2005-2006 Dmitriy Cherkashin
 email: divch@users.sourceforge.net, dch@ucrouter.ru
 site: www.ucrouter.ru phone: +7-910-422-2917
 MIT licence
*/


/* print todo message */
static int todo(void) 
{ 
 fprintf(stdout,
    "TODO\n"
 );
 return(1);
}

/* print Change Log */
static int changelog(void) 
{
 fprintf(stdout, "Change Log\n"
    "\n"
 );
 return(1);
}


static int usage(void)
{
 fprintf(stdout,"\nat91f_maker [lib_AT91RM9200.h] [lib_AT91RM9200.c] [lib_AT91RM9200.mk]\n"
    "\n"
 );
 return(1);
}

static char * buffer = 0;
static FILE * i_file = 0;
static FILE * o_file = 0;
static FILE * m_file = 0;
static char * i_name = 0;
static char * o_name = 0;
static char * m_name = 0;

static struct {
    char name[80];
} func[512];
static int f_count = 0;

int main(int argc, char *argv[])
{
 char ch;
 int pos; 
 int sz;

 if(argc >= 2) {
    if(strcmp(argv[1],"--todo") == 0) {
	todo(); 				// show TODO notes and  
        exit(1);
     } else 
     if(strcmp(argv[1],"--changelog") == 0) {
	changelog(); 			// show change log file 
        exit(1);
    } else     
    if(strcmp(argv[1],"--help") == 0) {
	usage();
	exit(1);
     }
 }

 i_name = "lib_AT91RM9200.h";
 if(argc >= 2) {
    i_name = argv[1];
 }

 i_file = fopen(i_name,"r+b");
 if(i_file == NULL) {
    fprintf(stderr, "\nFile [%s] open error\n", i_name); 
    exit(1);
 }

 sz = 0;
 ch = fgetc(i_file);
 while(feof(i_file) == 0) {
    sz++; 
    ch = fgetc(i_file);
 }
 sz += 1;

 rewind(i_file);
 buffer = (char *) malloc(sz);
 if(buffer == 0) {
    fprintf(stderr, "\nMemory alloc error\n");
    exit(1);
 }

 pos = 0;
 while(pos + 1 < sz) {
    ch = fgetc(i_file);
    *(buffer + pos) = ch;
    pos++;
 }
 *(buffer + pos) = '\0';

/* */
 fclose(i_file);

//
 o_name = "lib_AT91RM9200.c";
 if(argc >= 3) {
    o_name = argv[2];
 }
 o_file = fopen(o_name,"w+b");
 if(o_file == 0) {
    fprintf(stderr, "\nFile [%s] open error\n", o_name); 
    exit(1);
 }
 fprintf(o_file, "#include \"AT91RM9200.h\"\n");  
 fprintf(o_file, "#define __inline\n");  

 m_name = "lib_AT91RM9200.mk";
 if(argc >= 4) {
    m_name = argv[3];
 }
 m_file = fopen(m_name,"w+t");
 if(m_file == 0) {
    fprintf(stderr, "\nFile [%s] open error\n", m_name); 
    exit(1);
 }

 fprintf(m_file,  
   "CFLAGS = -DAT91RM9200 -Os -nostdinc -fno-builtin -fomit-frame-pointer -fno-strict-aliasing  -fno-common -mshort-load-bytes -msoft-float -march=armv4t -mtune=arm9tdmi -D__arm__ -I. -I./../../include\n"
   "LDFLAGS = -nostdlib  -Tld.script -Map loader.map\n"
   "AFLAGS = -mapcs-32 -msoft-float -mno-fpu -I. -I./../../include\n"
   "\n"
   "#  -march=armv4 -mtune=arm9tdmi\n"
   "##############################################################################\n"
   "CROSS_COMPILE=arm-linux-\n"
   "#CROSS_COMPILE = /usr/local/arm/2.95.3/bin/arm-linux-\n"
   "CC=$(CROSS_COMPILE)gcc\n"
   "LD=$(CROSS_COMPILE)ld\n"
   "AR=$(CROSS_COMPILE)ar\n"
   "\n"
   "OBJL ="
 );

 char * str;
 str = buffer;
 while(1) {
    char * ptr; 
    ptr = strstr(str, "__inline");
    if(ptr == 0) {
	while(*str != '\0') {
	    fputc(*str, o_file);
	    str++;
	} 
	{ break; }
    } 
    
    while(str != ptr) {
	fputc(*str, o_file);
	str++;
    }

    ptr += strlen("__inline");


    while(1) {
	int prc = 0;
	while(*ptr == ' ' || *ptr == '\t' || *ptr == '\n') {
	    ptr++; 
	    prc = 1;
	}

	if(prc == 1) {
	    continue;
	}
	
	if(strncmp(ptr, "unsigned", 8) == 0) {
	    ptr += 8;
	} else 
	if(strncmp(ptr, "void", 4) == 0) {
	    ptr += 4;
	} else 
	if(strncmp(ptr, "int",  3) == 0) {
	    ptr += 3;
	} else 
	if(strncmp(ptr, "long", 4) == 0) {
	    ptr += 4;
	} else 
	if(strncmp(ptr, "char", 4) == 0) {
	    ptr += 4;
	} else {
	    break;
	}
    }

    char nam[121];
    int npos = 0;
    while(*ptr != '\0') {
	if(*ptr == ' ' || *ptr == '\n' || *ptr == '(') {
	    break;
	}

	if(npos < 120) {
	    nam[npos++] = *ptr;
	}
	ptr++;
    }

    if(npos <= 120) {
	nam[npos] = '\0';
    } else {
	nam[120] = '\0';
    }

    printf("%s\n", nam);

/* */
    fprintf(o_file, "\n#ifdef __%s__\n", nam);
    while(*ptr != '\0') {
	if(*ptr == '{') {
	    ptr++;
	    break;
	}
	ptr++;
    }
    
    int cnt = 1;

    while(*ptr != '\0') {
	if(*ptr == '{') {
	    ptr++;
	    cnt++;
	} else
	if(*ptr == '}') {
	    cnt--;
	    ptr++;
	    if(cnt == 0) {
		break;
	    }
	} else {
	    ptr++;
	}
    }

    while(str != ptr) {
	fputc(*str, o_file);
	str++;
    }

    fprintf(o_file, "\n#endif %40s /* __%s__ */\n", "", nam);

    if(f_count < 512) {
	char * f_nam;
	int  f_len;

	f_nam = func[f_count].name;
	f_len = sizeof(func[f_count].name);

	memset(f_nam,   0, f_len);
	memcpy(f_nam, nam, f_len - 1);
	f_count++;
    }
/* */
    fprintf(m_file, " %c\n", '\\');
    fprintf(m_file, "   %s.o",  nam);
 } 

 fprintf(m_file, "\n\nall:at91f_lib.a\n\n");

 fprintf(m_file, "\n\n");
 fprintf(m_file, "at91f_lib.a : $(OBJL)\n");
 fprintf(m_file, "\t$(AR) crv at91f_lib.a $(OBJL)\n");
 fprintf(m_file, "\techo \'#include \"AT91RM9200.h\"\' >proto.tmp\n");
 fprintf(m_file, "\techo \'#define __inline\' >>proto.tmp\n");
 fprintf(m_file, "\tcat ./../../include/lib_AT91RM9200.h >>proto.tmp\n");
 fprintf(m_file, "\tcproto -I ./../../include -o ./../proto.h proto.tmp\n");
 fprintf(m_file, "\trm -f proto.tmp\n");

 {
    int fn;
    for(fn = 0; fn < f_count; ++fn) {
	fprintf(m_file, "%s.o : %s\n", 
	    func[fn].name , o_name
	);
	fprintf(m_file, "\t$(CC) -D__%s__  $(CFLAGS) -c -o $@ $<\n", 
	    func[fn].name);
	fprintf(m_file, "\n");
    }
 }


 fprintf(m_file,"clean:\n");
 fprintf(m_file,"\trm -f lib_AT91RM9200.c\n");
 fprintf(m_file,"\trm -f *.a\n");
 fprintf(m_file,"\trm -f *.o\n");

/* */
 fclose(o_file);
 fclose(m_file);

 return(0);
}
